#ifndef		__COMMAND_LINE_OPTION_H_
#define		__COMMAND_LINE_OPTION_H_


#ifdef	__cplusplus
extern	"C"	{
#endif


// Long option.
typedef		struct LongOpt
{
	const char	*name;		// Option name.
							// Name of the last option must be NULL.
	int			has_arg;	// Option has argument (1), has no argument (0),
							// may have argument (2).
	int			*flag;		// If flag isn't NULL,
							// opts_get() overwrites *flag by return value.
	int			val;		// Return value.
}	LongOpt, *hLongOpt;

// Command line option.
typedef		struct CmdOpt
{
	// Arguments.
	int		argc;
	char	**argv;

	// Setting.
	const LongOpt	*longopts;		// Long options.
	const char		*optstring;		// Option string.

	// Status.
	int		optind;		// Index of target option.
	char	*nextchar;	// Next character.
	char	*optarg;	// Argument of option.
	int		optopt;		// Option character.
	char	*optlong;	// Long option.
	int		opterr;		// Warning level ( 0: no, 1: error, 2: all ).
	int		longindex;	// Index of long option.
	int		optnum;		// Number of options.
}	CmdOpt, *hCmdOpt;


// Analyze command line option.
int		CmdOpt_Get( hCmdOpt h );
// Initialize structure.
void	CmdOpt_Init( hCmdOpt h, int argc, char **argv,
					 const char *optstring, const LongOpt *longopts );


#ifdef	__cplusplus
}
#endif


#endif
